#!/usr/bin/env python3

from distutils.core import setup, Extension

module1 = Extension('_sfp',
                    sources = [
                        'src/sfpmodule.cpp',
                        'src/libsfp/src/serial_framing_protocol.cpp',
                        ],
                    include_dirs = [
                        'src/libsfp/include',
                        'include',
                        'src/cxx-util/include',
                        ],
                    extra_compile_args = [
                        '-std=c++11',
                        '-g',
                        ],
                    )

setup (name = 'PySfp',
       version = '0.1.1',
       author = 'David Ko',
       author_email = 'david@barobo.com',
       url = 'http://github.com/BaroboRobotics/libsfp',
       description = 'This is a Python binding for Barobo\'s Serial Framing Protocol.',
       ext_modules = [module1],
       ext_package = 'sfp',
       packages = ['sfp'],
       )
